## openvpn-auth-okta 2.9.0

=== Makefile ===
SHELL := bash
.ONESHELL:
.SHELLFLAGS := -eu -o pipefail -c
MAKEFLAGS += --warn-undefined-variables
MAKEFLAGS += --no-builtin-rules
UNAME_S := $(shell uname -s)
OSDESC := $(shell [ -f /etc/os-release ] && . /etc/os-release && echo $$ID)
ifeq ($(OSDESC),raspbian)
CGO := 1
else
CGO := 0
endif

INSTALL := install
CC := gcc
INC := -I. -I./build
CFLAGS := -fPIC $(INC) -O2 -D_FORTIFY_SOURCE=2 -fstack-protector-strong
LDFLAGS := -shared -fPIC

DESTDIR :=
LIB_PREFIX := /usr/lib
PLUGIN_DIR := openvpn/plugins
BUILDDIR := build

GOPLUGIN_LDFLAGS := -ldflags '-s -w -extldflags "-static"'
GOPLUGIN_FLAGS := -trimpath -buildmode=pie -a $(GOPLUGIN_LDFLAGS)

ifeq ($(UNAME_S),Linux)
LIBOKTA_LDFLAGS := -ldflags '-s -w -extldflags -Wl,-soname,libokta-auth-validator.so'
CPLUGIN_LDFLAGS := $(LDFLAGS) -Wl,-soname,openvpn-plugin-auth-okta.so
else
# MacOs X
LIBOKTA_LDFLAGS := -ldflags '-s -w -extldflags -Wl,-install_name,libokta-auth-validator.so'
CPLUGIN_LDFLAGS := $(LDFLAGS) -Wl,-install_name,openvpn-plugin-auth-okta.so
endif
LIBOKTA_FLAGS := -trimpath -buildmode=c-shared $(LIBOKTA_LDFLAGS)

PKG_SRC := $(shell ls pkg/*/*.go | grep -v "_test.go")
PLUGIN_DEPS := $(BUILDDIR)/libokta-auth-validator.so $(BUILDDIR)/openvpn-plugin-auth-okta.o openvpn-plugin.h


all: binary plugin

$(BUILDDIR):
	mkdir $(BUILDDIR)

$(BUILDDIR)/%.o: %.c | $(BUILDDIR)
	$(CC) $(CFLAGS) -c $< -o $@

# Build the plugin as a standalone binary
binary: $(BUILDDIR)/okta-auth-validator
$(BUILDDIR)/okta-auth-validator: cmd/okta-auth-validator/main.go $(PKG_SRC) | $(BUILDDIR)
	CGO_ENABLED=$(CGO) go build $(GOPLUGIN_FLAGS) -o $(BUILDDIR)/okta-auth-validator cmd/okta-auth-validator/main.go

# Build the openvpn-plugin-auth-okta plugin (linked against the Go c-shared lib)
$(BUILDDIR)/openvpn-plugin-auth-okta.so: $(PLUGIN_DEPS)
	$(CC) $(CPLUGIN_LDFLAGS) -o $(BUILDDIR)/openvpn-plugin-auth-okta.so $(BUILDDIR)/openvpn-plugin-auth-okta.o

# Build the okta-auth-validator shared lib (Golang c-shared)
$(BUILDDIR)/libokta-auth-validator.so: lib/libokta-auth-validator.go $(PKG_SRC) | $(BUILDDIR)
	go build $(LIBOKTA_FLAGS) -o $(BUILDDIR)/libokta-auth-validator.so lib/libokta-auth-validator.go

# Build all shared libraries
plugin: $(BUILDDIR)/libokta-auth-validator.so $(BUILDDIR)/openvpn-plugin-auth-okta.so

test: $(BUILDDIR)/cover.out

coverage: $(BUILDDIR)/coverage.html

# Run gobagde to update the README coverage badge after golang tests
badge: $(BUILDDIR)/cover-badge.out
	if [ ! -f /tmp/gobadge ]; then \
		curl -sf https://gobinaries.com/github.com/AlexBeauchemin/gobadge@v0.3.0 | PREFIX=/tmp sh; \
	fi
	/tmp/gobadge -filename=$(BUILDDIR)/cover-badge.out

# Run tests that generates the cover.out
$(BUILDDIR)/cover.out: | $(BUILDDIR)
	# Ensure tests wont fail because of crappy permissions
	chmod -R g-w,o-w testing/fixtures
	go test ./pkg/... -v -cover -coverprofile=$(BUILDDIR)/cover.out -covermode=atomic -coverpkg=./pkg/...

# Creates the coverage.html
$(BUILDDIR)/coverage.html: $(BUILDDIR)/cover.out
	go tool cover -html=$(BUILDDIR)/cover.out -o $(BUILDDIR)/coverage.html

# Creates the cover-badgeout (needed for README badge link creation)
$(BUILDDIR)/cover-badge.out: $(BUILDDIR)/cover.out
	go tool cover -func=$(BUILDDIR)/cover.out -o=$(BUILDDIR)/cover-badge.out


# You'll need to install golangci-lint and cppcheck
# see https://github.com/danmar/cppcheck#packages
# https://github.com/golangci/golangci-lint#install-golangci-lint
lint:
	golangci-lint run
	cppcheck $(INC) --enable=all --disable=missingInclude --check-level=exhaustive *.c

install: all
	mkdir -p $(DESTDIR)/$(LIB_PREFIX)/$(PLUGIN_DIR)
	mkdir -p $(DESTDIR)/etc/okta-auth-validator/
	mkdir -p $(DESTDIR)/usr/include
	mkdir -p $(DESTDIR)/usr/bin
	$(INSTALL) -m755 $(BUILDDIR)/okta-auth-validator $(DESTDIR)/usr/bin/
	$(INSTALL) -m644 $(BUILDDIR)/libokta-auth-validator.so $(DESTDIR)/$(LIB_PREFIX)/
	$(INSTALL) -m644 $(BUILDDIR)/libokta-auth-validator.h $(DESTDIR)/usr/include/
	$(INSTALL) -m644 $(BUILDDIR)/openvpn-plugin-auth-okta.so $(DESTDIR)/$(LIB_PREFIX)/$(PLUGIN_DIR)/
	if [ ! -f $(DESTDIR)/etc/okta-auth-validator/pinset.cfg ]; then \
		$(INSTALL) -m644 config/pinset.cfg $(DESTDIR)/etc/okta-auth-validator/pinset.cfg; \
	fi
	if [ ! -f $(DESTDIR)/etc/okta-auth-validator/api.ini ]; then \
		$(INSTALL) -m640 config/api.ini.inc $(DESTDIR)/etc/okta-auth-validator/api.ini; \
	fi

clean:
	rm -Rf $(BUILDDIR)
	rm -f testing/fixtures/validator/valid_control_file
	rm -f testing/fixtures/validator/invalid_control_file
	rm -f testing/fixtures/validator/control_file

.PHONY: clean binary install lint badge coverage test plugin

=== debian/changelog ===
openvpn-auth-okta (2.9.0) stable; urgency=medium

  [ Jeremy JACQUE ]
  * chore(doc): update list of available distro / arch
  * feat: add an potion to configure a separator between the VPN password and the TOTP passcode
  * chore(validator): ensure the separator length is 1 - a character
  * clean(validator/test): the TestParsePassword func has been move to utils test
  * chore: add missing test for separator validity in ini file

  [ dependabot[bot] ]
  * chore(deps): bump github.com/go-playground/validator/v10
  * chore(deps): bump github.com/phuslu/log from 1.0.117 to 1.0.119

 -- Jeremy JACQUE <jeremy.jacque@algolia.com>  Tue, 19 Aug 2025 14:03:31 +0200

openvpn-auth-okta (2.8.6) stable; urgency=medium

  [ dependabot[bot] ]
  * chore(deps): bump github.com/go-playground/validator/v10
  * chore(deps): bump github.com/go-playground/validator/v10
  * chore(deps): bump golang.org/x/net from 0.34.0 to 0.36.0

  [ Jeremy JACQUE ]
  * chore(test): use linkname to access OktaApiAuth pool in validator tests
  * chore(deps): bump go to 1.24.1

  [ dependabot[bot] ]
  * chore(deps): bump github.com/phuslu/log from 1.0.113 to 1.0.117

  [ dependabot[bot] ]
  * chore(deps): bump golang.org/x/net from 0.36.0 to 0.38.0

  [ dependabot[bot] ]
  * chore(deps): bump github.com/go-playground/validator/v10
  * chore(dist): Update changelog for 2.8.6 release

 -- Jeremy JACQUE <jeremy.jacque@algolia.com>  Wed, 30 Apr 2025 20:22:00 +0200

openvpn-auth-okta (2.8.5) stable; urgency=medium

  [ dependabot[bot] ]
  * chore(deps): bump github.com/go-playground/validator/v10
  * chore(deps): bump github.com/phuslu/log from 1.0.107 to 1.0.110
  * chore(deps): bump github.com/phuslu/log from 1.0.110 to 1.0.111
  * chore(deps): bump github.com/phuslu/log from 1.0.111 to 1.0.112
  * chore(deps): bump github.com/phuslu/log from 1.0.112 to 1.0.113
  * chore(deps): bump github.com/go-playground/validator/v10
  * chore(deps): bump github.com/stretchr/testify from 1.9.0 to 1.10.0
  * chore(deps): bump golang.org/x/crypto from 0.21.0 to 0.31.0

  [ Jeremy JACQUE ]
  * chore(deps): set go version to 1.22
  * chore(ci): update codacy-coverage-reporter orb to 14.0.2
  * chore: update go to 1.23
  * chore(ci): update golangci-lint to 1.62.2

 -- Jeremy JACQUE <jeremy.jacque@algolia.com>  Thu, 12 Dec 2024 14:30:57 +0100

openvpn-auth-okta (2.8.4) stable; urgency=medium

  [ dependabot[bot] ]
  * chore(deps): bump github.com/phuslu/log from 1.0.106 to 1.0.107

  [ Jeremy JACQUE ]
  * chore(oktaApiAuth): use Chrome on Linux user agent along with Sec-CH headers
  * chore(oktaApiAuth): improve Push factor debugging

 -- Jeremy JACQUE <jeremy.jacque@algolia.com>  Mon, 01 Jul 2024 11:56:41 +0000

openvpn-auth-okta (2.8.3) stable; urgency=medium

  [ dependabot[bot] ]
  * chore(deps): bump github.com/phuslu/log from 1.0.97 to 1.0.100
  * chore(deps): bump github.com/phuslu/log from 1.0.100 to 1.0.101
  * chore(deps): bump github.com/phuslu/log from 1.0.101 to 1.0.102
  * chore(deps): bump github.com/go-playground/validator/v10

  [ Jeremy JACQUE ]
  * chore(dist): build using Golang 1.22
  * chore(doc): fix codacy warnings in README
  * chore(ci): disable codacy checks for fixtures and test code
  * chore(doc): add codacy badge
  * fix(Makefile): /etc/os-release does not exist on MacOS, test before sourcing
  * chore(ci): push coverage report to Codacy
  * chore(lib): deduplicate identical piece of code
  * chore(doc): fix more markdown warnings

  [ dependabot[bot] ]
  * chore(deps): bump github.com/phuslu/log from 1.0.102 to 1.0.106

  [ dependabot[bot] ]
  * chore(deps): bump github.com/go-playground/validator/v10
  * chore: use sentinel errors when possible
  * fix(oktaApiAuth): do not print authRes.Result when it is empty
  * refacto(oktaApiAuth): dedup JSON api response processing
  * chore(doc): update coverage badge
  * fix(oktaApiAuth): gofmt
  * test(oktaApiAuth): use assert.EqualError instead of assert.Equal
  * test: use testify dedicated errors functions
  * fix: use a valid hardcoded user agent
  * chore(doc): update available package distros and archs
  * fix(oktaApiAuth): respect Go style guide
  * fix(oktaApiAuth): use fmt.Errorf instead of errors.New of fmt string
  * refacto(oktaApiAuth): simplify Okta Auth error handling using wrappers
  * chore(doc): update coverage badge
  * fix(oktaApiAuth): wrong authRes variable was tested
  * test(oktaApiAuth): add tests for parseOktaError

 -- Jeremy JACQUE <jeremy.jacque@algolia.com>  Wed, 26 Jun 2024 17:26:52 +0000

openvpn-auth-okta (2.8.2) stable; urgency=medium

  [ dependabot[bot] ]
  * chore(deps): bump github.com/stretchr/testify from 1.8.4 to 1.9.0
  * chore(deps): bump github.com/go-playground/validator/v10
  * chore(deps): bump github.com/phuslu/log from 1.0.88 to 1.0.89
  * chore(deps): bump github.com/phuslu/log from 1.0.89 to 1.0.90
  * chore(deps): bump golang.org/x/net from 0.21.0 to 0.23.0
  * chore(deps): bump github.com/phuslu/log from 1.0.90 to 1.0.91
  * chore(deps): bump github.com/go-playground/validator/v10
  * chore(deps): bump github.com/phuslu/log from 1.0.91 to 1.0.92
  * chore(deps): bump github.com/phuslu/log from 1.0.92 to 1.0.93
  * chore(deps): bump github.com/phuslu/log from 1.0.93 to 1.0.96
  * chore(deps): bump github.com/phuslu/log from 1.0.96 to 1.0.97

  [ Jeremy JACQUE ]
  * feat(lib): allow to use a struct for PluginEnv
  * feat(lib): provide a way to compute lib args from plugin envp, args passed as a struct
  * fix(Makefile): use proper inc dirs for gcc and cppcheck
  * feat(lib): rename the C function computing args
  * doc: add some comments
  * fix(lib): gotfmt
  * chore(lib): let the user allocate and free himself the ArgsOktaAuthValidatorV2 struct
  * refacto(plugin): mutualize error code during lib related calls
  * chore(cmd): add missing license header

 -- Jeremy Jacque <jeremy.jacque@algolia.com>  Tue, 07 May 2024 12:47:00 +0000

openvpn-auth-okta (2.8.1) stable; urgency=medium

  [ dependabot[bot] ]


=== debian/control ===
Source: openvpn-auth-okta
Section: net
Priority: optional
Maintainer: Jeremy Jacque <jeremy.jacque@algolia.com>
Build-Depends: debhelper (>=10), make, gcc, golang-1.24
Standards-Version: 0.1
Homepage: https://github.com/algolia/openvpn-auth-okta

Package: openvpn-auth-okta
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}, libokta-auth-validator (= ${source:Version}), okta-auth-validator-common (= ${source:Version})
Description: This is a plugin for OpenVPN (Community Edition) that authenticates users directly against Okta, with support for MFA.

Package: okta-auth-validator
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}, libokta-auth-validator (= ${source:Version}), okta-auth-validator-common (= ${source:Version})
Description: This is a command line tool that authenticates users directly against Okta, with support for MFA.

Package: libokta-auth-validator
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}, okta-auth-validator-common (= ${source:Version})
Suggests: libokta-auth-validator-dev
Description: Shared library that allows to authenticates user directly against Okta, with support for MFA.

Package: libokta-auth-validator-dev
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Development files for libokta-auth-validator.

Package: okta-auth-validator-common
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Config files for okta-auth-validator.
